document.addEventListener('readystatechange', function () {
  if (document.readyState === 'interactive') {
    initApp();
  };
});

function initApp() {
  // adicina o menu
  var menu = '' +
    '  <button id="menu" type="button" data-toggle="modal" data-target="#menuModal">Menu</button>' +
    '  <button id="top" type="button">Menu</button>' +
    '' +
    '  <!-- Modal -->' +
    '  <div class="modal fade" id="menuModal" tabindex="-1" role="dialog" aria-labelledby="menuModal" aria-hidden="true">' +
    '    <div class="modal-dialog modal-lg" role="document">' +
    '      <div class="modal-content">' +
    '        <div class="modal-header">' +
    '          <h5 class="modal-title">Templates</h5>' +
    '          <button type="button" class="close" data-dismiss="modal" aria-label="Close">' +
    '            <span aria-hidden="true">×</span>' +
    '          </button>' +
    '        </div>' +
    '        <div class="modal-body p-4">' +
    '          <div id="menuGrid" class="row"></div>' +
    '        </div>' +
    '      </div>' +
    '    </div>' +
    '  </div>';
  $('body').prepend(menu);

  $('.template').each(function (i, v) {
    var id = i;
    var name = $(this).attr('data-name');
    var description = $(this).attr('data-description');
    var code = $(this).html();

    // adiciona template no menu
    var menuitem = '<div class="menu-col"><a href="#' + name + '">' + name + '</a><br>' + description + '</col>';
    $('#menuGrid').append(menuitem);

    // cria a barra sobre o template
    var snippet_bar = '<a class="anchor" name="' + name + '"></a><div class="snippet_bar"><h2><strong>' + name + '</strong> - ' + description + '</h2><button data-copy="' + id + '">Copiar</button></div>';
    $(this).before(snippet_bar);

    // cria textarea com o código do template
    var snippet_code = '<pre class="snippet_code"><code data-code="' + id + '"></code></pre>';
    $(this).after(snippet_code);
    $('[data-code="' + id + '"]').text(code);
  });

  // ao clicar em um link do menu rola a tela até o template
  $("#menuGrid a").on("click", function (e) {
    e.preventDefault();
    var hash = $(this).attr("href");
    console.log(hash);
    $('#menuModal').on('hidden.bs.modal', function (e) {
      location.hash = hash;
    })
    $("#menuModal").modal('hide');
  });

  // ao clicar no botão copia o código do template para a área de transferência
  $('[data-copy]').on('click', function () {
    $this = $(this);
    templateid = $this.attr('data-copy');
    code = $('[data-code=' + templateid + ']').text();
    if (copyClipboard(code)) {
      $this.text("Copiado!");
      setTimeout(function () {
        $this.text("Copiar");
      }, 1500);
    };
  });

  $(window).scroll(function () {
    if ($(window).scrollTop() > 300) {
      btn.addClass('show');
    } else {
      btn.removeClass('show');
    }
  });

  var btn = $('#top');
  btn.on('click', function (e) {
    e.preventDefault();
    $('html, body').animate({ scrollTop: 0 }, '100');
  });
};

function copyClipboard(code) {
  var temp = $("<textarea>");
  $("body").append($(temp));
  $(temp).val(code).select();
  document.execCommand("copy");
  $(temp).remove();
  return true;
};